##SCRIPT FOR PROCESSING MCL OUTPUT FOR FEEDING TO JCE
##Created by Marc Facciotti 11/11/2015
##1. NEED GFF FILES (DERIVED FROM PARSING .GBK FILE) - MAKE SURE TO RENAME .GBK FILE WITH GENOME NAME FROM "ORGANISM" FLAG
##2. NEED THE OUTPUT FILE FROM MCL - WILL LIKELY HAVE A .mlc suffix with inflation parameter appended
##3. CREATE DIRECTORIES for (A) original GFF Files (B) new GFF Files (C) GBK files (D) MCL OUTPUT
##4. FOR THE MOMENT - RUN SCRIPT IN PARTS and VERIFY OUTPUT BEFORE PROCEEDING TO NEXT STEP
##5. YOU CAN AND SHOULD THINK ABOUT STARTING MULTIPLE INSTANCES OF STEP 3 

##STEP 1 - CREATE NEW GFFs
##SET WORKING DIRECTORY TO NEW GFFwID directory
##Read in file names - SET PATH TO original GFF Files directory here 
gff.names2 <- list.files("/Users/YOUR/PATH/TO/ORGANISM/POST_MCL/GFF",full=FALSE)
gff.files2 <- list.files("/Users/YOUR/PATH/TO/ORGANISM/POST_MCL/GFF",full=TRUE)

##READ IN EACH INDIVIDUAL OLD GFF INTO A MATRIX gffContent
for (p in 1:length(gff.names2)){
  gffContent <- as.matrix(read.table(gff.files2[p], sep='\t',quote="",colClasses=c("character","character","character","character","character", "character", "character", "character","character","character"), fill=TRUE)) 
  
  ##Create blank vector to populate with annotation
  blankv <- vector(mode="character", length=dim(gffContent)[1])
  
  #Create a matrix to store elements for gene name
  namesMat <- matrix(NA, ncol=4,nrow=dim(gffContent)[1])
  for (l in 1:dim(gffContent)[1]){
    namesMat[l,1] <- sub("^([^.]*).*", "\\1",gff.names2[p])
    namesMat[l,2] <- gffContent[l,1]
    namesMat[l,3] <- as.numeric(gffContent[l,4])
    namesMat[l,4] <- as.numeric(gffContent[l,5])
  }
  
  #Fill blank vector with new gene name
  for (m in 1:dim(gffContent)[1]){
    blankv[m] <- paste(namesMat[m,1],"--",namesMat[m,2],"--",namesMat[m,3],"--", namesMat[m,4], sep="")
  }
  
  #Append the new vector to old GFF on column 11 in new matrix newGFFwID
  newGFFwID <- cbind(gffContent,blankv)
  #Write out new file with ID appended
  write.table(newGFFwID, paste(sub("^([^.]*).*", "\\1",gff.names2[p]),"_wID.gff", sep=""),sep='\t',quote=FALSE,row.names=FALSE,col.names=FALSE)
}

###END STEP 1
#####BREAK HERE TO MAKE SURE EVERYTHING WORKED!!!!
#####BREAK HERE TO MAKE SURE EVERYTHING WORKED!!!!
#####BREAK HERE TO MAKE SURE EVERYTHING WORKED!!!!
#####BREAK HERE TO MAKE SURE EVERYTHING WORKED!!!!



##STEP 2 - REFORMAT THE OUTPUT OF MCL 
##TAKE ACTION HERE!! SPECIFY DIRECTORIES
#READ THE OUTPUT OF MCL - SPECIFY DIRECTORY AND FILE
rawMCL <- read.table("/Users/YOUR/PATH/TO/ORGANISM/Clustering/MCL_Clusters/out.FILE_ALL_BLAST_filtered.mci.I25", fill=TRUE, na.strings="NA")

#MAKE a two column matrix from datamat with gene and clusterID
geneClust <- matrix(NA, ncol=2, nrow=length(which(rawMCL!="")))

#Start to fill the geneClust Matrix by scanning each element and assigning its line number
#initialize counter
a <- 1
#Iterate over each line
for (i in 1:(dim(rawMCL))[1]){
  #print(i/(dim(rawMCL)[1])*100)
#Read each element in the line; first find the number of non-empty elements
  for (b in 1:length(which(rawMCL[i,]!=""))){

#Write each line to the geneClust Matrix
    geneClust[a,1] <- as.character(rawMCL[i,b])
    geneClust[a,2] <- i
##update counter
a <- a+1
  }
}

##WRITE THE NEW FILE FOR POSTERITY AND IF NECESSARY REUSE W/OUT RECALC

write.table(geneClust,"Cluster_ID_Assign.txt",sep='\t',quote=FALSE,row.names=FALSE,col.names=FALSE)

###END STEP 2
###CHECK THAT IT WORKED
###CHECK THAT IT WORKED



##STEP 3 - GENERATE THE CLUSTER FILE FOR JCE
##NOTE THIS CAN BE MANUALLY SPLIT UP IF YOUR MACHINE HAS MULTIPLE CORES - FOR EXAMPLE IF YOUR MACHINE HAS 8 CORES
##AND YOU HAVE 20 GFFs TO READ, YOU CAN START 8 R INSTANCES AND PARSE THE FILE LOAD WITH 2-3 FILES PER NODE
##FOR EACH MAKE SURE TO WRITE OUT A CLEAN (TABLE LACKING NAs) AND CAT ALL THE FILES TOGETHER AT THE END

gff.files <- list.files("/Users/YOUR/PATH/TO/ORGANISM/POST_MCL/GFFwID",  full=TRUE)
rawMCL <- read.table("/Users/YOUR/PATH/TO/ORGANISM/Clustering/MCL_Clusters/out.FILE_ALL_BLAST_filtered.mci.I25", fill=TRUE, na.strings="NA")

##MAKE SURE THIS FILE ISNT IN THE SAME DIRECTORY AS THE GFFs
geneClust2 <- read.table("/Users/YOUR/PATH/TO/ORGANISM/POST_MCL/Cluster_ID_Assign.txt", colClasses=c("character","character"))

#AT THE MOMENT READ IN FILE FOR CONVIENIENCE OF GRABBING GENOME NAMES - IF FINE NAMED APPROPRIATELY CAN WORK
gff.names3 <- list.files("/Users/YOUR/PATH/TO/ORGANISM/POST_MCL/GFF",full=FALSE)

#CREATE A NEW MATRIX TO HOLD DATA 
outMat <- matrix(NA, ncol=5, nrow=length(which(geneClust2!="")))

##these should be variablized for parallelization depending on cores available CAN CHANGE THESE BY HAND
## instructions on how to do two or three files at a time: replace line below with: for(g in 1:2){    or    for(g in 3:4){
for(g in 1:length(gff.names3)){
  print(g/length(gff.names3)*100)
 
 ## tevert to gff <- read.table(gff.files[g],sep='\t',colClasses=c("character","character","character", "numeric", "numeric", "character", "numeric", "character", "character", "numeric","character"), quote="") 
  gff <- read.table(gff.files[g],sep='\t',colClasses=c("character","character","character", "numeric", "numeric", "character", "numeric", "character", "character", "numeric","character"), quote="")
  print("Matching......")
  
  for(h in 1:nrow(gff)){
    #Match the gene name to the line containing it in GeneCluster to get line assignment
    row.num <- grep(gff[h,11],geneClust2[,1])
    
    #grab the file name with regex, replace with capture group #1
    #outMat[row.num,1] <- sub("(\w*_\w+_\w+[^\--\s])", "\\1",gff[h,])
    outMat[row.num,1] <- sub("^([^.]*).*", "\\1", gff.names3[g])
    #fill in new columns in outMat from gff file columns
    outMat[row.num,2] <- gff[h,1]
    outMat[row.num,3] <- gff[h,4]
    outMat[row.num,4] <- gff[h,5]
    #assign the cluster number by 
    outMat[row.num,5] <- as.numeric(geneClust2[row.num,2])
  }
}

####FOR MULTIPLE RUNS - AT THE MOMENT PASTE UP TO HERE FOR STEP THREE
###END STEP 3 - IF SPLITTING THIS BETWEEN MULTIPLE R SESSIONS


###STEP 4 FOR SPLIT RUNS - ELSE IGNORE IF JUST RUNNING ON ITS OWN
#####FOR SPLIT RUNS MAKE THIS STEP 4
###STEP 4 CUT PASTE THIS INTO THE R SESSION AFTER PREVIOUS LOOPS ARE DONE
##Create a new matrix with no NA rows
exportMat <- outMat[rowSums(is.na(outMat))!=5,]

###IMPORTANT TO MODIFY HERE IF SPLITTING JOB
##Write a file for JCE Change File Name to include range of genomes into range of files specified above
write.table(exportMat,"ClusterID_ALL.txt",sep='\t',quote=FALSE,row.names=FALSE,col.names=FALSE)

###END STEP 3 SINGLE RUN
###END STEP 4 SPLIT RUN
##IF the jobs in Step 3 were split it is now time to gather all of the output and cat the files together into a master file

